#ifndef _PROC_PROCPS_H
#define _PROC_PROCPS_H

#include <stdio.h>
#include <sys/types.h>

#include "proc/readproc.h"

#define STRINGIFY_ARG(a)	#a
#define STRINGIFY(a)		STRINGIFY_ARG(a)

/* flags for dev_to_tty */
#define ABBREV_DEV  1		/* remove /dev/ */
#define ABBREV_TTY  2		/* remove tty/ */
#define ABBREV_PTS  4		/* remove pts/ */

typedef int (*cmp_t) (void *, void *);

extern char * wchan(unsigned long long);
extern char * group_from_gid(gid_t);
extern char * user_from_uid(uid_t);
extern int open_psdb(const char *override);
extern int open_psdb_message(const char *override,
		void (*message) (const char *, ...));
extern void close_psdb(void);
extern void make_fnctbl(void);
extern int mult_lvl_cmp(void *a, void *b);
extern void reset_sort_options(void);
extern void register_sort_function(int, cmp_t);
extern char * get_task_status(proc_t *task);
extern void print_uptime(void);
extern void list_signals(void);
extern int get_signal(char *);
extern int dev_to_tty(char *, int, int, int, unsigned int);
extern int tty_to_dev(char *);

#endif /* _PROC_PROCPS_H */
